# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import osv, fields

class account_journal(osv.osv):
    _inherit = "account.journal"
    _columns = {
        'cc_allow_processing': fields.boolean('Allow Credit Card Processing',),
        'cc_allow_refunds': fields.boolean('Allow Credit Card Refunds',),
    }
account_journal()


class res_partner(osv.osv):
    _inherit = "res.partner"

    def write(self, cr, uid, ids, vals, context=None):
        if vals.get('bank_ids',[]) and len(vals['bank_ids'][0]) > 3 and vals['bank_ids'][0][2] :
            if vals['bank_ids'][0][2].get('cc_number',False):
                if ('XXXXXXXXX' in vals['bank_ids'][0][2]['cc_number']):
                    del vals['cc_number']
        result = super(res_partner, self).write(cr, uid, ids, vals, context)
        return True


res_partner()

class res_partner_bank(osv.osv):
    '''Bank Accounts'''

    def read(self, cr, user, ids, fields=None, context=None, load='_classic_read'):
        if context is None:
            context = {}
        vals = super(res_partner_bank,self).read(cr,user,ids,fields,context,load)
        if context.get('cc_no','') != 'no_mask':
            if len(vals) == 1:
                if vals[0].get('cc_number',False):
                    t = vals[0]['cc_number']
                    i = len(t)-4
                    vals[0]['cc_number'] = 'X'*i+t[-4:len(t)]
        return vals
    
    _inherit = "res.partner.bank"
    _columns = {
        'cc_number':fields.char('Credit Card Number', size=256),#Given size 256 because the credit card is stored as encrypted format.
#        'cc_type':fields.many2one('cc.type','Card type'),
        'cc_e_d_month':fields.char('Expiration Date MM', size=32),
        'cc_e_d_year':fields.char('Expiration Date YY', size=32),
        'cc_v':fields.char('Card Code Verification', size=32),
    }
res_partner_bank()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: