# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import osv, fields
from Crypto.Cipher import DES3
import base64

def get_encrypt_key(key='mY_p@ssw0rd_kEy_'):
    return key

#def get_encrypt_key(key='mY_p@ssw0rd_kEy_'):
#    if not os.path.exists('./des_config.cfg'):
#        fp = open('./des_config.cfg','wb')
#        fp.write(key)
#        fp.close()
#    else:
#        fp = open('./des_config.cfg','rb')
#        key = fp.read()
#        fp.close()
#    return key

class AuthnetAIMError(Exception):
    def __init__(self, value):
        self.parameter = value
    def __str__(self):
        return str(self.parameter)

class account_voucher(osv.osv):

    def setParameter(self, parameters={}, key=None, value=None):

        if key != None and value != None and str(key).strip() != '' and str(value).strip() != '':
            parameters[key] = str(value).strip()
        else:
            raise AuthnetAIMError('Incorrect parameters passed to setParameter(): {0}:{1}'.format(key, value))
        return parameters
    
    def cancel_cc(self, cr, uid, ids, context=None):
        return self.write(cr, uid, ids, { 'cc_number':'',
                                       'cc_e_d_month':'',
                                       'cc_e_d_year':'',
                                       'cc_v':'',
                                       'cc_auth_code':'',
                                       'cc_trans_id':'', })
        
    def authorize(self, cr, uid, ids, context=None):
#        self.do_transaction(cr, uid, ids,refund=False, context=context)
        return False

    def cc_refund(self, cr, uid, ids, context=None):
#        self.do_transaction(cr, uid, ids, refund=True,context=context)
        return True

    def _get_zip(self, cr, uid, ids, zip_id, context={}):
        if zip_id:
                zip_code = self.pool.get('address.zip').browse(cr, uid, zip_id)
                return zip_code.zipcode
        return ''
    
    def _get_country(self, cr, uid, ids, country_id, context={}):
          if country_id:
              country = self.pool.get('res.country').browse(cr, uid, country_id)
              return country.name
          return ''

    def _get_state(self, cr, uid, ids, state_id, context={}):
        if state_id:
              state = self.pool.get('res.country.state').browse(cr, uid, state_id)
              return state.name
        return ''

    def _get_cardholder_details(self, cr, uid, ids, partner_id, context={}):
        ret = {}
        if partner_id:
            partner = self.pool.get('res.partner').browse(cr, uid, partner_id)
            ret = {'name':partner.name,
                'street':partner.address[0].street,
                'street2':partner.address[0].street2,
                'city':partner.address[0].city,
                'country':self._get_country(cr, uid, ids, partner.address[0].country_id.id),
                "zip":partner.address[0].zip,
                "state":self._get_state(cr, uid, ids, partner.address[0].state_id.id),
                'title':partner.title and partner.title.name
                }
        return ret

    def create(self, cr, uid, vals, context=None):
        '''
        Encrypt credit card number before writing to database
        '''
        if vals.get('cc_number', False):
            if 'XXXXX' in vals['cc_number']:
                del vals['cc_number']
            else:
                encrytipn_obj = DES3.new(get_encrypt_key(), DES3.MODE_ECB)
                i = len(vals['cc_number']) % 8
                i = (8 - i)
                plain_text = vals['cc_number'] + 'X' * i
                ciphered_text = encrytipn_obj.encrypt(plain_text)
                vals['cc_number'] = base64.encodestring(ciphered_text)
                vals['cc_length'] = i
        result = super(account_voucher, self).create(cr, uid, vals, context)
        vouch = self.browse(cr, uid, result, context=context)
        if vouch.rel_sale_order_id:
            self.pool.get('sale.order').write(cr, uid, [vouch.rel_sale_order_id.id], {'rel_account_voucher_id':result})
        return result
    
    def write(self, cr, uid, ids, vals, context=None):
        '''
        Encrypt credit card number before writing to database
        '''
        if vals.get('cc_number', False):
            if 'XXXXX' in vals['cc_number']:
                del vals['cc_number']
            else:
                encrytipn_obj = DES3.new(get_encrypt_key(), DES3.MODE_ECB)
                i = len(vals['cc_number']) % 8
                i = (8 - i)
                plain_text = vals['cc_number'] + 'X' * i
                ciphered_text = encrytipn_obj.encrypt(plain_text)
                vals['cc_number'] = base64.encodestring(ciphered_text)
                vals['cc_length'] = i
        result = super(account_voucher, self).write(cr, uid, ids, vals, context)
        return result
    
    def read(self, cr, user, ids, fields=None, context={}, load='_classic_read'):
        '''
        Decrypt credit card number after reading from database and display last four digits if there is 
        no no_mask in context
        '''
        if fields and 'cc_number' in fields and 'cc_length' not in fields:
            fields.append('cc_length')
        if not ids:
            return []
        vals = super(account_voucher, self).read(cr, user, ids, fields, context, load)
        if ids and type(ids) == type([]):
            val = vals[0]
        else:
            val = vals
        if val.get('cc_number', False) and val.get('cc_length', False):
            encrytipn_obj = DES3.new(get_encrypt_key(), DES3.MODE_ECB)
            back = encrytipn_obj.decrypt(base64.decodestring(val['cc_number']))
            i = val['cc_length']
            i = -i
            plain_text = back[:i]
            val['cc_number'] = plain_text
        else:
            val['cc_number'] = ''
        if context.get('cc_no', '') != 'no_mask':
            if len(vals) == 1:
                if val.get('cc_number', False):
                    t = val['cc_number']
                    i = len(t) - 4
                    val['cc_number'] = 'X' * i + t[-4:len(t)]
        if type(ids) == type([]):
            vals[0] = val
        else:
            vals = val

        return vals


    def copy(self, cr, uid, id, default=None, context=None):
        """Overrides orm copy method
        @param self: The object pointer
        @param cr: the current row, from the database cursor,
        @param uid: the current user’s ID for security checks,
        @param ids: List of case’s IDs
        @param context: A standard dictionary for contextual values
        """
        if default is None:
            default = {}
        default.update({'cc_number': '', 'cc_length': 0, 'cc_v':'', 'cc_e_d_month':'', 'cc_e_d_year':''})
        return super(account_voucher, self).copy(cr, uid, id, default=default, context=context)


    def oncahnge_pre_authorize(self, cr, uid, ids, cc_p_authorize, context={}):
        if cc_p_authorize:
            return {'value':{'cc_charge':False, 'cc_p_authorize':True } }
        return {'value':{'cc_charge':True, 'cc_p_authorize':False } }

    def oncahnge_cc_charge(self, cr, uid, ids, cc_charge, context={}):
        if cc_charge:
            return {'value':{'cc_charge':True, 'cc_p_authorize':False } }            
        return {'value':{'cc_charge':False, 'cc_p_authorize':True } }

    _inherit = 'account.voucher'
    _columns = {
        'cc_name':fields.char('Cardholders Name', size=32,),
        'cc_b_addr_1':fields.char('Billing Address1', size=32,),
        'cc_b_addr_2':fields.char('Billing Address2', size=32,),
        'cc_city': fields.char('City', size=32,),
        'cc_state':fields.char('State', size=32,),
        'cc_zip':fields.char('Postal/Zip', size=32,),
        'cc_country':fields.char('Country', size=32,),
        'cc_order_date':fields.date('Order Date',),
        'cc_order_amt':fields.float('Order Amt',),
        'cc_number':fields.char('Credit Card Number', size=256),
        'cc_v':fields.char('Card Code Verification', size=32,),
        'cc_e_d_month':fields.char('Expiration Date MM', size=32),
        'cc_e_d_year':fields.char('Expiration Date YY', size=32),
        'cc_comment':fields.char('Comment', size=128,),
        'cc_auth_code':fields.char('Authorization Code', size=32),
        'cc_save_card_details':fields.boolean('Save Credit Card details'),
        'cc_ecommerce_sale':fields.boolean('Ecommerce sale'),
        'cc_p_authorize':fields.boolean('Pre-authorize'),
        'cc_charge':fields.boolean('Charge'),
        'cc_info_hide':fields.boolean('Credit Info Hide'),
        'cc_status':fields.text('Status Message'),
        'cc_details_autofill':fields.boolean('Credit Card Details Auto Fill'),
        'cc_reseller':fields.boolean('Reseller'),
        'rel_sale_order_id':fields.many2one('sale.order', 'Related Sale Order'),
        'cc_trans_id':fields.char('Transaction ID', size=128),
        'cc_bank':fields.many2one('res.bank', 'Bank'),
        'cc_details':fields.many2one('res.partner.bank', 'Bank'),
        'cc_length':fields.integer('CC Length'),
        'cc_transaction':fields.boolean('Transaction Done'),
    }
    _defaults = {
        'cc_info_hide': lambda * a: True,
        'cc_p_authorize': lambda * a: True,
    }

    def onchange_cc_details(self, cr, uid, ids, cc_details, context={}):
        dic = {}
        if cc_details:
            context['cc_no'] = 'no_mask'
            bank = self.pool.get('res.partner.bank').browse(cr, uid, cc_details, context=context)
            dic['cc_e_d_month'] = bank.cc_e_d_month
            dic['cc_e_d_year'] = bank.cc_e_d_year
            dic['cc_number'] = bank.cc_number
            dic['cc_v'] = bank.cc_v
        return {'value':dic}

    def onchange_partner_id(self, cr, uid, ids, partner_id, journal_id, price, currency_id, ttype, date, context={}, sale_id=False):
        res = super(account_voucher, self).onchange_partner_id(cr, uid, ids, partner_id, journal_id, price, currency_id, ttype, date, context=context)
        if not res.has_key('value'):
            res['value'] = {}
        jorurnal_cc_allow = False
        cardholder_details = self._get_cardholder_details(cr, uid, ids, partner_id, context=context)
        if journal_id and cardholder_details:
            jorurnal_cc_allow = self.pool.get('account.journal').read(cr, uid, journal_id, ['cc_allow_processing'])['cc_allow_processing']
            res['value']['cc_name'] = cardholder_details['name']
            res['value']['cc_b_addr_1'] = cardholder_details['street']
            res['value']['cc_b_addr_2'] = cardholder_details['street2']
            res['value']['cc_city'] = cardholder_details['city']
            res['value']['cc_country'] = cardholder_details['country']
            res['value']['cc_zip'] = cardholder_details['zip']
            res['value']['cc_state'] = cardholder_details['state']
            res['value']['cc_reseller'] = cardholder_details['title'] == 'Reseller' and True or False
            res['value']['cc_save_card_details'] = False
        if jorurnal_cc_allow:
            res['value']['cc_info_hide'] = False
        else:
            res['value']['cc_info_hide'] = True

        if not context:
            context = {}
        context.update({'sale_id':sale_id})
        if not sale_id:
            sale_id = context.get('sale_id')
            
        if sale_id and res['value'].get('line_cr_ids') :
            sale = self.pool.get('sale.order').browse(cr, uid, sale_id, context=context)
            lines = []
            for line in res['value']['line_cr_ids']:
                for invoice in sale.invoice_ids:
                    if not (line.get('invoice_id') and line.get('invoice_id') and line['invoice_id'] == invoice.id):
                        line['pay'] = False
                    else:
                        line['pay'] = True
                        line['amount'] = line['amount_original']
                    
                lines.append(line)
            res['value']['line_cr_ids'] = lines
        
        return res
account_voucher()

class res_company(osv.osv):
    '''
    Add credit card details on company configuration
    '''
    _inherit = "res.company"
    _columns = {
        'cc_login': fields.char('CreditCard Login ID', size=64),
        'cc_transaction_key': fields.char('Transaction Key', size=64),
        'cc_testmode': fields.boolean('Test Mode'),
        'cc_journal_id':fields.many2one('account.journal', 'Payment Method', help="The default payment method on payment voucher open using the Pay button from sale order."),
        'cc_refund_journal_id' : fields.many2one('account.journal', 'Refund Journal', help="The default refund journal for credit card payments.")
    }
res_company()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
